module.exports = function(RED) {
    function progressbar(config) {
        RED.nodes.createNode(this,config);
        var node = this;
        var globalContext = node.context().global;

        var progressbar = globalContext.get('progressbar') || {};
        progressbar.value = progressbar.value || 0;
        progressbar.stepup = config.stepup; // in milliseconds
        progressbar.stepdown = config.stepdown; // in milliseconds

        var timeoutid
        progressbar.refresh = function(msg){
            if (progressbar.value > 100 || progressbar.value < 0 || progressbar.action == "stop"){
            if (progressbar.value > 100) progressbar.value = 100;
            if (progressbar.value <0 ) progressbar.value = 0;
            clearTimeout(timeoutid);
            globalContext.set('progressbar', progressbar);
            node.status({});
            }else{
            if (progressbar.action == "up"){
              progressbar.value -= 1;
              clearTimeout(timeoutid);
              timeoutid = setTimeout(progressbar.refresh, progressbar.stepup, msg);
            }
            if (progressbar.action == "down"){
              progressbar.value += 1;
              clearTimeout(timeoutid);
              timeoutid = setTimeout(progressbar.refresh, progressbar.stepdown, msg);
            }
            }
            msg.payload = progressbar.value;
            node.send(msg);
        };

        var node = this;
        node.on('input', function(msg) {
            node.status({fill:"green",shape:"dot",text:"working"});
            progressbar.action = msg.topic.split("/").pop() || "stop";
            progressbar.refresh(msg);
        });
    }
    RED.nodes.registerType("progressbar",progressbar);
}
